//create instances of drawer object here using info above

Drawer drawer1(drawer1array, drawer1size, drawer1num);
Drawer drawer2(drawer2array, drawer2size, drawer2num);
Drawer drawer3(drawer3array, drawer3size, drawer3num);
Drawer drawer4(drawer4array, drawer4size, drawer4num);
Drawer drawer5(drawer5array, drawer5size, drawer5num);
Drawer drawer6(drawer6array, drawer6size, drawer6num);
Drawer drawer7(drawer7array, drawer7size, drawer7num);
Drawer drawer8(drawer8array, drawer8size, drawer8num);
Drawer drawer9(drawer9array, drawer9size, drawer9num);
Drawer drawer10(drawer10array, drawer10size, drawer10num);
Drawer drawer11(drawer11array, drawer11size, drawer11num);
Drawer drawer12(drawer12array, drawer12size, drawer12num);
Drawer drawer13(drawer13array, drawer13size, drawer13num);
Drawer drawer14(drawer14array, drawer14size, drawer14num);
Drawer drawer15(drawer15array, drawer15size, drawer15num);
Drawer drawer16(drawer16array, drawer16size, drawer16num);

Adafruit_MCP23017 mcp;

void setup()
{
  Serial.begin(9600);
  randomSeed(analogRead(0));
  mp3.begin(9600);
  delay(500);
  sendCommand(CMD_SEL_DEV, 0, 0);
  sendCommand(CMD_SET_VOLUME, 0, 29);

  delay(200);
  mcp.begin();  // initializes MPC port expansion chip

  for (int x = 0; x < 17; x++)
  {
    mcp.pinMode(x, INPUT); // set pins on mcp chip as inputs
    mcp.pullUp(x, LOW);  // turn on a 100K pullup internally
  }
  Serial.begin(9600);
  pinMode(13, OUTPUT);  // use an LED on Pin 13 for debugging
  Serial.println("START");

  delay(200);
  drawer1.shuffle();
  drawer2.shuffle();
  drawer3.shuffle();
  drawer4.shuffle();
  drawer5.shuffle();
  drawer6.shuffle();
  drawer7.shuffle();
  drawer8.shuffle();
  drawer9.shuffle();
  drawer10.shuffle();
  drawer11.shuffle();
  drawer12.shuffle();
  drawer13.shuffle();
  drawer14.shuffle();
  drawer15.shuffle();
  drawer16.shuffle();

  Serial.println("BEGIN");
  Serial.println();
}


void loop() {

  static bool playingAudio = false; // variable tracks whether mp3 chip is playing
  static bool doOnlyOnce = false; // corrects error on Mp3 chip that sends serial reply twice (only allows the first reply through)

  drawerState1 = mcp.digitalRead(drawer1pin);
  drawerState2 = mcp.digitalRead(drawer2pin);
  drawerState3 = mcp.digitalRead(drawer3pin);
  drawerState4 = mcp.digitalRead(drawer4pin);
  drawerState5 = mcp.digitalRead(drawer5pin);
  drawerState6 = mcp.digitalRead(drawer6pin);
  drawerState7 = mcp.digitalRead(drawer7pin);
  drawerState8 = mcp.digitalRead(drawer8pin);
  drawerState9 = mcp.digitalRead(drawer9pin);
  drawerState10 = mcp.digitalRead(drawer10pin);
  drawerState11 = mcp.digitalRead(drawer11pin);
  drawerState12 = mcp.digitalRead(drawer12pin);
  drawerState13 = mcp.digitalRead(drawer13pin);
  drawerState14 = mcp.digitalRead(drawer14pin);
  drawerState15 = mcp.digitalRead(drawer15pin);
  drawerState16 = mcp.digitalRead(drawer16pin);

  if (!playingAudio && drawerState1 == 1) // if audio isn't playing, AND this drawer is open,
  {
    drawerNumber = 1;     // set drawer number to this drawer,
    drawerOpen = true;    // then tell system there is in fact a drawer open...
    drawer1.play();       // and then play the file.
    playingAudio = true;  // Now tell the system that there's audio playing...
    drawer1.allPlayedChecker(); // and check to see if all the files have been played before reshuffling.
  }

  if (!playingAudio && drawerState2 == 1)
  {
    drawerNumber = 2;
    drawerOpen = true;
    drawer2.play();
    playingAudio = true;
    drawer2.allPlayedChecker();
  }

  if (!playingAudio && drawerState3 == 1)
  {
    drawerNumber = 3;
    drawerOpen = true;
    drawer3.play();
    playingAudio = true;
    drawer3.allPlayedChecker();
  }

  if (!playingAudio && drawerState4 == 1)
  {
    drawerNumber = 4;
    drawerOpen = true;
    drawer4.play();
    playingAudio = true;
    drawer4.allPlayedChecker();
  }

  if (!playingAudio && drawerState5 == 1)
  {
    drawerNumber = 5;
    drawerOpen = true;
    drawer5.play();
    playingAudio = true;
    drawer5.allPlayedChecker();
  }

  if (!playingAudio && drawerState6 == 1)
  {
    drawerNumber = 6;
    drawerOpen = true;
    drawer6.play();
    playingAudio = true;
    drawer6.allPlayedChecker();
  }

  if (!playingAudio && drawerState7 == 1)
  {
    drawerNumber = 7;
    drawerOpen = true;
    drawer7.play();
    playingAudio = true;
    drawer7.allPlayedChecker();
  }

  if (!playingAudio && drawerState8 == 1)
  {
    drawerNumber = 8;
    drawerOpen = true;
    drawer8.play();
    playingAudio = true;
    drawer8.allPlayedChecker();
  }

  if (!playingAudio && drawerState9 == 1)
  {
    drawerNumber = 9;
    drawerOpen = true;
    drawer9.play();
    playingAudio = true;
    drawer9.allPlayedChecker();
  }

  if (!playingAudio && drawerState10 == 1)
  {
    drawerNumber = 10;
    drawerOpen = true;
    drawer10.play();
    playingAudio = true;
    drawer10.allPlayedChecker();
  }

  if (!playingAudio && drawerState11 == 1)
  {
    drawerNumber = 11;
    drawerOpen = true;
    drawer11.play();
    playingAudio = true;
    drawer11.allPlayedChecker();
  }
  if (!playingAudio && drawerState12 == 1)
  {
    drawerNumber = 12;
    drawerOpen = true;
    drawer12.play();
    playingAudio = true;
    drawer12.allPlayedChecker();
  }

  if (!playingAudio && drawerState13 == 1)
  {
    drawerNumber = 13;
    drawerOpen = true;
    drawer13.play();
    playingAudio = true;
    drawer13.allPlayedChecker();
  }

  if (!playingAudio && drawerState14 == 1)
  {
    drawerNumber = 14;
    drawerOpen = true;
    drawer14.play();
    playingAudio = true;
    drawer14.allPlayedChecker();
  }

  if (!playingAudio && drawerState15 == 1)
  {
    drawerNumber = 15;
    drawerOpen = true;
    drawer15.play();
    playingAudio = true;
    drawer15.allPlayedChecker();
  }

  if (!playingAudio && drawerState16 == 1)
  {
    drawerNumber = 16;
    drawerOpen = true;
    drawer16.play();
    playingAudio = true;
    drawer16.allPlayedChecker();
  }

  if (mp3.available()) // Checks for reply from mp3 player
  {
    decodeMP3Answer(); // decode binary and turn bytes into HEX
    if (ansbuf[3] == 0x3d) // if the HEX code for "file is done" comes in,
    {
      doOnlyOnce = !doOnlyOnce; // ... only pay attention to that first reply,
      if (doOnlyOnce)
      {
        Serial.println("finished playing audio file");
        Serial.println();
        playingAudio = false; //...and tell the system there's NO AUDIO playing.
      }
    }
  }



  if (drawerOpen && drawerState1 == 0 // When all the drawers are closed...
      && drawerState2 == 0
      && drawerState3 == 0
      && drawerState4 == 0
      && drawerState5 == 0
      && drawerState6 == 0
      && drawerState7 == 0
      && drawerState8 == 0
      && drawerState9 == 0
      && drawerState10 == 0
      && drawerState11 == 0
      && drawerState12 == 0
      && drawerState13 == 0
      && drawerState14 == 0
      && drawerState15 == 0
      && drawerState16 == 0)
  {
    sendCommand(CMD_STOP_PLAY, 0, 0); // tell mp3 player to stop what it's doing...
    playingAudio = 0;                 // tell the rest of the system there's no audio playing...
    drawerNumber = 0;
    drawerOpen = false;               // ...and that there are no drawers are open.
    Serial.println();
    Serial.println("all drawers CLOSED!");
    Serial.println();
  }

  delay(10);
}



